<template>
    <v-card  style="height: calc(100vh - 150px);" class="mx-auto">
      <l-map
        style="height: 80%;"
        ref="mapresult"
        v-if="showMap"
        :zoom="zoom"
        :center="center"
        :options="mapOptions"
        @update:center="centerUpdate"
        @update:zoom="zoomUpdate"
      >
        <l-control-fullscreen
          position="topleft"
          :options="{ title: { false: 'Go big!', true: 'Be regular' } }"
        />

        <l-tile-layer :url="url" :attribution="attribution" />
        <v-marker-cluster>
          <l-marker
            v-for="coord in airportsLocation"
            :lat-lng="coord"
            :key="coord.toString()"
            :icon="planeicon"
          >
          </l-marker>
          <l-marker
            v-for="price in fiteredPrices"
            :lat-lng="price.latLng"
            :key="price.latLng.toString() + Math.random()"
          >
            <l-icon :icon-anchor="staticAnchor" class-name="someExtraClass">
              <div class="headline">
                <p>{{ price.price }}€</p>
              </div>
              {{ price.address }}
            </l-icon>
          </l-marker>
        </v-marker-cluster>
      </l-map>
      <v-card-actions>
        <v-slider
          class="pa-8"
          :max="maxprice"
          :min="minprice"
          v-model="maxValue"
          thumb-label="always"
        ></v-slider>
      </v-card-actions>
    </v-card>
</template>
<script>
import { latLng, icon, latLngBounds } from "leaflet";
import "leaflet/dist/leaflet.css";
import Vue2LeafletMarkerCluster from "vue2-leaflet-markercluster";
import LControlFullscreen from "vue2-leaflet-fullscreen";

import { LMap, LTileLayer, LMarker, LIcon } from "vue2-leaflet";

export default {
  name: "Result",
  components: {
    LMap,
    LTileLayer,
    LMarker,
    LIcon,
    LControlFullscreen,
    "v-marker-cluster": Vue2LeafletMarkerCluster,
  },
  data() {
    return {
      zoom: 5,
      center: latLng(47.41322, -1.219482),
      url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",
      attribution:
        '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
      currentZoom: 11.5,
      currentCenter: latLng(47.41322, -1.219482),
      showParagraph: false,
      mapOptions: {
        zoomSnap: 0.5,
      },
      staticAnchor: [16, 37],
      showMap: true,
      maxValue: 0,
      planeicon: icon({
        iconUrl: require("../assets/plane-pin.png"),
        iconSize: [60, 60],
        iconAnchor: [30, 60],
      }),
    };
  },
  computed: {
    airportsLocation: {
      get() {
        let locs = this.$store.getters.getChoosenAirportsLocation;
        return Object.values(locs).map((coord) => latLng(coord.lat, coord.lng));
      },
    },
    prices: {
      get() {
        let locs = this.$store.getters.getPrices;
        return locs.map((e1) => {
          return {
            price: Math.round(e1.price / this.airportsLocation.length),
            latLng: latLng(e1.coord.lat, e1.coord.lng),
            address: e1.address,
          };
        });
      },
    },
    maxprice() {
      return this.prices.length == 0
        ? 0
        : Math.ceil(
            Math.max.apply(
              Math,
              this.prices.map((el) => el.price)
            )
          );
    },
    minprice() {
      return this.prices.length == 0
        ? 0
        : Math.ceil(
            Math.min.apply(
              Math,
              this.prices.map((el) => el.price)
            )
          );
    },
    fiteredPrices() {
      return this.prices.filter((price) => price.price <= this.maxValue);
    },
    step: {
      get() {
        return this.$store.getters.getStep;
      },
    },
  },
  methods: {
    zoomUpdate(zoom) {
      this.currentZoom = zoom;
    },
    centerUpdate(center) {
      this.currentCenter = center;
    },
    display(price) {
      return price <= this.maxValue;
    },
  },
  watch: {
    airportsLocation: function(val) {
      this.$refs.mapresult.fitBounds(new latLngBounds(val).pad(0.2));
    },
    maxprice: function(val) {
      this.maxValue = val;
    },
    step: function(step) {
      if (step == 3) {
        setTimeout(
          () => this.$refs.mapresult.mapObject.invalidateSize(true),
          200
        );
      }
    },
  },
};
</script>
<style>
@import "~leaflet.markercluster/dist/MarkerCluster.css";
@import "~leaflet.markercluster/dist/MarkerCluster.Default.css";

.someExtraClass {
  background-color: black;
  color: white;
  padding: 10px;
  border: 1px solid #333;
  border-radius: 0 20px 20px 20px;
  box-shadow: 5px 3px 10px rgba(0, 0, 0, 0.2);
  text-align: center;
  width: auto !important;
  height: auto !important;
  margin: 0 !important;
}
</style>
